HDU-2473-Junk-Mail Filter(并查集删除)

Problem Description
Recognizing junk mails is a tough task. The method used here consists of two steps:
1) Extract the common characteristics from the incoming email.
2) Use a filter matching the set of common characteristics extracted to determine whether the email is a spam.

We want to extract the set of common characteristics from the N sample junk emails available at the moment, and thus having a handy data-analyzing tool would be helpful. The tool should support the following kinds of operations:

a) “M X Y”, meaning that we think that the characteristics of spam X and Y are the same. Note that the relationship defined here is transitive, so
relationships (other than the one between X and Y) need to be created if they are not present at the moment.

b) “S X”, meaning that we think spam X had been misidentified. Your tool should remove all relationships that spam X has when this command is received; after that, spam X will become an isolated node in the relationship graph.

Initially no relationships exist between any pair of the junk emails, so the number of distinct characteristics at that time is N.
Please help us keep track of any necessary information to solve our problem.
 

Input
There are multiple test cases in the input file.
Each test case starts with two integers, N and M (1 ≤ N ≤ 105 , 1 ≤ M ≤ 106), the number of email samples and the number of operations. M lines follow, each line is one of the two formats described above.
Two successive test cases are separated by a blank line. A case with N = 0 and M = 0 indicates the end of the input file, and should not be processed by your program.
 

Output
For each test case, please print a single integer, the number of distinct common characteristics, to the console. Follow the format as indicated in the sample below.
 

Sample Input
5 6

M 0 1

M 1 2

M 1 3

S 1

M 1 2

S 3

3 1

M 1 2

0 0
 

Sample Output
Case #1: 3

Case #2: 2


思路:并查集删除。

要点:1.建立虚拟父节点。box的最大数为2*n+m的最大值。2.集合数不能直接遍历所有集合,因为有可能有些虚拟集合并没有被用,只有被用过的才能算在集合数里。

坑点:本题节点从0开始,而不是1。


#include<cstdio>
#include<cstring>
using namespace std;
int n,m;
int pre[1200005];
int mark[1200005]; 

int find(int x){
    while(pre[x]!=x){
        int r=pre[x];
        pre[x]=pre[r];
        x=r;
    }
    return x;        
}

void merge(int x,int y){
    int fx=find(x);
    int fy=find(y);
    if(fx!=fy)
        pre[fy]=fx;        
}

int main(){
    char c[5];
    int x,y;
    int no=0;
    while(scanf("%d%d",&n,&m)&&(n||m)){
        no++;
        int l=0;
        for(int i=0;i<2*n+m;i++){
             if(i<n)  pre[i]=i+n;
             else pre[i]=i;
        }
        for(int i=0;i<m;i++){
            scanf("%s",&c);
            if(c[0]=='M'){
                scanf("%d%d",&x,&y);
                merge(x,y);            
            }
            else {
                scanf("%d",&x);           
                pre[x]=2*n+l;
                l++;                 
            }        
        }
        
        int cnt=0;
        memset(mark,0,sizeof(mark));
        for(int i=0;i<n;i++){
            if(mark[find(pre[i])]) continue;
            cnt++;
            mark[find(pre[i])]=1;
        }
        
        printf("Case #%d: %d
",no,cnt);        
    }
    return 0;
} 

原文地址:https://www.cnblogs.com/yzhhh/p/9948359.html